unit UInput;

interface

type
  //----------------------------------------------------------------------------
  TInput = class
  private
    flip:integer;
  protected
    keys:Array[0..1,0..255]of boolean;
  public
    constructor Create;
    procedure GetState();virtual;
    function IsPress( key:BYTE ):boolean;
    function IsPush( key:BYTE ):boolean;
  end;

  //----------------------------------------------------------------------------
  TInputKeyboard = class(TInput)
  public
    procedure GetState();override;
  end;


implementation

uses windows;

//----------------------------------------------------------------------------
constructor TInput.Create;
var i:integer;
begin
  flip := 0;
  for i:=0 to 255 do
  begin
    keys[0,i]:=False;
    keys[1,i]:=False;
  end;
end;

procedure TInput.GetState();
begin
  if flip = 0 then flip:=1
  else             flip:=0;
end;

function TInput.IsPress( key:BYTE ):boolean;
begin
  Result := keys[flip,key];
end;

function TInput.IsPush( key:BYTE ):boolean;
begin
  Result := True;
  if not keys[  flip,key] then Result := False;
  if     keys[1-flip,key] then Result := False;
end;

//----------------------------------------------------------------------------
procedure TInputKeyboard.GetState();
var i:integer;
begin
  inherited;
  for i:=0 to 255 do
  begin
    if (GetAsyncKeyState(i) and $8000) <> 0 then keys[flip,i] := True
    else                                         keys[flip,i] := False;
  end;
end;








end.
