unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, mmsystem, UGame, URender, UMath;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);

    procedure IdleHandler(Sender:TObject; var Done:Boolean);

  private
    { Private 錾 }
    render:TRender;
    player:TPlayer;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  view,proj:TMatrix;
begin
  //XN[TCY
  ClientWidth  := 640;
  ClientHeight := 480;

  //_̐Ɛݒ
  render := TRender.Create(640,480);
  proj := MatProjection( Deg2Rad(80), ClientWidth/ClientHeight, 0, 1000 );
  render.SetProj(proj);

  //V[̐
  player := TPlayer.Create(render);

  //܂Ȃ
  TimeBeginPeriod(1);
  Application.OnIdle := IdleHandler;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  TimeEndPeriod(1);
  player.Free;
  render.Free;
end;

procedure TForm1.IdleHandler(Sender:TObject; var Done:Boolean);
var
  BeginTime:DWORD;
  m,view,proj:TMatrix;
begin
  //Jn
  BeginTime := TimeGetTime;

  //ItXN[̏
  render.Clear;

  //vC[XV
  player.Update(1);

  //ItXN[`
  render.Present( Canvas.Handle, Rect(0,0,ClientWidth,ClientHeight) );

  //1t[̎Ԃ]҂
  Done := False;
  while (TimeGetTime-BeginTime)<(1000 div 60) do; //60fps
end;

end.
